﻿using Photon.Pun;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;

public class GameEventListener_PhotonView : MonoBehaviour
{
    public GameEvent_PhotonView Event;
    public UnityEvent_PhotonView Response;

    private void OnEnable()
    {
        Event.RegisterListener(this);
    }

    private void OnDisable()
    {
        Event.UnRegisterListener(this);
    }

    public void OnEventRaised(PhotonView photonView)
    {
        Response.Invoke(photonView);
    }
}

[System.Serializable]
public class UnityEvent_PhotonView : UnityEvent<PhotonView>
{
}
